#!/usr/bin/perl
# Use whereis to find perl on your web server

$mailprog = '/usr/sbin/sendmail';
# Use whereis to find sendmail on your web server

# Tested with Perl 5.004	version f1.1				#

# IN-A-FLASH(TM), a trademark of Virtual Light Studios	#
# This code is (C) 2000 Virtual Light Studios (VLS)		#
# Do not distribute without this notice					#
# Cannot be resold										#
# VLS is not responsible for anything bad that might	#
# happen because you used this software, nor does VLS	#
# guarantee this software will work for you				#

@referers = ('tangible.new21.org');
# Add your web server to referers

# Check Referring URL
&check_url;

# Parse Form Contents
&parse_form;

# Send E-Mail
&send_mail;

#### Check Referer ####

sub check_url { 

	if ($ENV{'HTTP_REFERER'}) {
		foreach $referer (@referers) {
			if ($ENV{'HTTP_REFERER'} =~ m|https?://([^/]*)$referer|i) {
				last;
			} else {
				die;
            }
		} 
	}
}

#### Read In Form Fields (everybody uses this) ####

sub parse_form {

	if ($ENV{'REQUEST_METHOD'} eq 'GET') {
		# Split the name-value pairs
		@pairs = split(/&/, $ENV{'QUERY_STRING'});
	} else {
		read(STDIN, $ARGV[0], $ENV{'CONTENT_LENGTH'});
		@pairs = split(/&/, $ARGV[0]);
	}

	foreach $pair (@pairs) {
		($name, $value) = split(/=/, $pair);
		$value =~ tr/+/ /;
		$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
  		$value =~ s/<!--(.|\n)*-->//g;      # Gets rid of server-side includes
		$FORM{$name} = $value;
	}
	
	$message = $FORM{'message'};
	$message =~ s/\r/\n/g; #Converts carriage returns to newline chars
	
}

#### The Main Send Routine ####

sub send_mail {

    open(MAIL,"|$mailprog -t");

    print MAIL "To: $FORM{'recipient'}\n";
    print MAIL "From: $FORM{'email'} ($FORM{'realname'})\n";
	print MAIL "Subject: $FORM{'subject'}\n\n";
    print MAIL "$message";
    
    close (MAIL);
    
}
